package com.ruoyi.system.domain.enums.config;

import java.util.Objects;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 配置项枚举
 * @author wjh
 * 2024/3/26
 */
@AllArgsConstructor
@Getter
public enum ConfigKey {

    SERVICE_FEE_RATE("sm.transactionBill.serviceFee", "充值服务费费率"),
    WITHDRAW_SERVICE_FEE_RATE("sm.transactionBill.widthDraw.serviceFee", "提现服务费费率"),
    WECHAT_APPROVAL("sys.wechat.approval", "微信小程序敏感内容展示");

    private final String key;
    private final String msg;

    public static ConfigKey parse(String key) {
        for (ConfigKey obj : ConfigKey.values()) {
            if (Objects.equals(obj.getKey(), key)) {
                return obj;
            }
        }
        throw new RuntimeException("不存在值为" + key + "的配置项");
    }
}