package com.ruoyi.ss.deviceBindRecord.service;

import com.ruoyi.ss.deviceBindRecord.domain.SmDeviceBindRecord;

import java.util.List;

/**
 * 设备绑定记录Service接口
 *
 * @author ruoyi
 * @date 2024-04-17
 */
public interface ISmDeviceBindRecordService
{
    /**
     * 查询设备绑定记录
     *
     * @param recordId 设备绑定记录主键
     * @return 设备绑定记录
     */
    public SmDeviceBindRecord selectSmDeviceBindRecordByRecordId(Long recordId);

    /**
     * 查询设备绑定记录列表
     *
     * @param smDeviceBindRecord 设备绑定记录
     * @return 设备绑定记录集合
     */
    public List<SmDeviceBindRecord> selectSmDeviceBindRecordList(SmDeviceBindRecord smDeviceBindRecord);

    /**
     * 新增设备绑定记录
     *
     * @param smDeviceBindRecord 设备绑定记录
     * @return 结果
     */
    public int insertSmDeviceBindRecord(SmDeviceBindRecord smDeviceBindRecord);

    /**
     * 修改设备绑定记录
     *
     * @param smDeviceBindRecord 设备绑定记录
     * @return 结果
     */
    public int updateSmDeviceBindRecord(SmDeviceBindRecord smDeviceBindRecord);

    /**
     * 批量删除设备绑定记录
     *
     * @param recordIds 需要删除的设备绑定记录主键集合
     * @return 结果
     */
    public int deleteSmDeviceBindRecordByRecordIds(Long[] recordIds);

    /**
     * 删除设备绑定记录信息
     *
     * @param recordId 设备绑定记录主键
     * @return 结果
     */
    public int deleteSmDeviceBindRecordByRecordId(Long recordId);

    int record(Long userId, Long deviceId);
}
